IM Flutter SDK 是基于原生 iOS/Android SDK 开发的，`所有的消息都是在 iOS/Android SDK 进行收发与编解码`的

如果需要自定义消息，需要按照下面的流程处理

```
1.编写 iOS/Android 层面的自定义消息
2.使用 iOS/Android 原生 SDK 注册自定义消息
3.Flutter 编写对应的自定义消息
4.Flutter 发送自定义消息
```
上面第四步需要保证自定义消息在原生平台能够正常编解码，建议`调试时候 debug 看一下 iOS 的 encode 和 decodeWithData 方法、Android 的 构造方法和 encode 方法`，保证自定义消息能够被 iOS/Android 正常的编解码


`由于 Flutter 目前不支持反射，所以自定义的消息无法被正常解码，自定义消息的数据会被放在 Flutter Message 和 Conversation 对象的 originContentMap 中`


[iOS 自定义消息实现文档](https://docs.rongcloud.cn/im/imkit/ios/custom/conversation/)

[Android 自定义消息文档](https://support.rongcloud.cn/ks/ODgz)


另外本项目中已经提供了自定义消息的范例，可查看源码实现

```
iOS 自定义消息：RCDTestMessage.h

Android 自定义消息：TestMessage.java

Flutter 自定义消息：test_message.dart
```
